# Tamito KAJIYAMA <4 February 2001>

from eb import *

import os

path = os.path.join(os.getcwd(), "ej")
disc = EB_DISC_EPWING
char = EB_CHARCODE_JISX0208
subbooks = [[0, "¡±Ѽŵ", "EJ"]]
list = tuple(map(lambda subbook: subbook[0], subbooks))
count = len(list)

def check_book(results):
    assert(results[0] == eb_is_bound(book))
    assert(results[1] == eb_path(book))
    assert(results[2] == eb_disc_type(book))
    assert(results[3] == eb_character_code(book))
    assert(results[4] == eb_subbook_list(book))
    assert(results[5] == eb_subbook_count(book))
    assert(results[6] == eb_subbook(book))
    assert(results[7] == eb_subbook_title(book))
    assert(results[8] == eb_subbook_directory(book))

def check_subbook(results):
    assert(results[0] == eb_subbook(book))
    assert(results[1] == eb_subbook_title(book))
    assert(results[1] == eb_subbook_title2(book, results[0]))
    assert(results[2] == eb_subbook_directory(book))
    assert(results[2] == eb_subbook_directory2(book, results[0]))

def test_bound():
    check_book((1, path, disc, char, list, count, -1, None, None))
    for subbook, title, directory in subbooks:
        assert(eb_set_subbook(book, subbook) == 0)
        check_subbook((subbook, title, directory))
        assert(eb_unset_subbook(book) == None)
        check_subbook((-1, None, None))
        assert(eb_set_subbook(book, subbook) == 0)
        check_subbook((subbook, title, directory))
        assert(eb_suspend(book) == None)
        check_subbook((-1, None, None))
        assert(eb_set_subbook(book, subbook) == 0)
        check_subbook((subbook, title, directory))

def test_unbound():
    check_book((0, None, -1, -1, None, -1, -1, None, None))
    for subbook, title, directory in subbooks:
        assert(eb_set_subbook(book, subbook) == -1)
        check_subbook((-1, None, None))
        assert(eb_unset_subbook(book) == None)
        check_subbook((-1, None, None))
        assert(eb_set_subbook(book, subbook) == -1)
        check_subbook((-1, None, None))
        assert(eb_suspend(book) == None)
        check_subbook((-1, None, None))
        assert(eb_set_subbook(book, subbook) == -1)
        check_subbook((-1, None, None))

book = EB_Book()
test_unbound()

assert(eb_bind(book, path) == 1)
test_bound()

assert(eb_clear(book) == None)
test_unbound()

assert(eb_bind(book, path) == 1)
test_bound()
