# Tamito KAJIYAMA <4 February 2001>

from eb import *

def hook_font(book, appendix, buffer, code, argv):
    if code == EB_HOOK_NARROW_FONT:
        if eb_narrow_alt_character_text(appendix, argv[0], buffer) < 0:
            buffer.set("<gaiji=h%04x>" % argv[0])
    elif code == EB_HOOK_WIDE_FONT:
        if eb_wide_alt_character_text(appendix, argv[0], buffer) < 0:
            buffer.set("<gaiji=z%04x>" % argv[0])
    return 0

def hook_newline(book, appendix, buffer, code, argv):
    buffer.set("<br>\n")
    return 0

def hook_tags(book, appendix, buffer, code, argv):
    if code == EB_HOOK_BEGIN_KEYWORD:
        buffer.set("<keyword>")
    elif code == EB_HOOK_END_KEYWORD:
        buffer.set("</keyword>")
    elif code == EB_HOOK_BEGIN_REFERENCE:
        buffer.set("<reference>")
    elif code == EB_HOOK_END_REFERENCE:
        buffer.set("</reference=%04x:%04x>" % (argv[1], argv[2]))
    return 0

text_hooks = (
    (EB_HOOK_NEWLINE,         hook_newline),
    (EB_HOOK_NARROW_FONT,     hook_font),
    (EB_HOOK_WIDE_FONT,	      hook_font),
    (EB_HOOK_BEGIN_KEYWORD,   hook_tags),
    (EB_HOOK_END_KEYWORD,     hook_tags),
    (EB_HOOK_BEGIN_REFERENCE, hook_tags),
    (EB_HOOK_END_REFERENCE,   hook_tags))

def search(func, word):
    assert(eb_search_exactword(book, word) == 0)
    buffer = []
    while 1:
        hitlist = eb_hit_list(book)
        if hitlist == -1:
            raise
        if not hitlist:
            break
        buffer.extend(list(hitlist))
    for heading, text in buffer:
        print "Position: %04x:%04x" % text
        eb_seek(book, heading)
        print "Heading:", eb_heading(book, appendix, hookset)
        eb_seek(book, text)
        print "Text:", eb_text(book, appendix, hookset)

book, appendix, hookset = EB_Book(), EB_Appendix(), EB_Hookset()
assert(eb_set_hooks(hookset, text_hooks) == 0)

assert(eb_bind(book, "ej") > 0)
assert(eb_set_subbook(book, 0) == 0)

search(0, "襤")
search(0, "襤餷")
search(0, "Ѥ")
search(0, "smiley")
